Subject: Re: [Imap-uw] Imapd-2004e and Solaris 10

From: Gregory Hicks <[email-masked]>
Date: Wed, 17 Aug 2005 15:00:57 -0700 (PDT)

> Date: Wed, 17 Aug 2005 13:20:46 -0700
> From: Mark Crispin <[email-masked]>
> 
> On Wed, 17 Aug 2005, Chris Ross wrote:
> >  I am one who prefers BSD systems myself, but you shouldn't make
> > such pronouncements about Solaris, or SysV in general.
> 
> Solaris, like all other SVR4 type systems, has serious technical
> deficiences in its kernel which render it unsuitable for use with an
> IMAP server.
> 
> This is my opinion, but it is strongly rooted in verifiable fact.

I must have the only Solaris IMAP server in the world that works and
works and keeps on working...  (I'm thinking of changing the name of
the machine to e-bunny (using as an example, the "Energizer Bunny")
since it keep on running...)

(Maybe not.  Energizer might take offense...)

-------------------------------------------------------------------
Gregory Hicks                        | Principal Systems Engineer
Cadence Design Systems               | Direct:   408.576.3609
555 River Oaks Pkwy M/S 6B1          | Fax:      408.894.3400
San Jose, CA 95134                   | Internet: [email-masked]

I am perfectly capable of learning from my mistakes.  I will surely
learn a great deal today.

"A democracy is a sheep and two wolves deciding on what to have for
lunch.  Freedom is a well armed sheep contesting the results of the
decision." - Benjamin Franklin

"The best we can hope for concerning the people at large is that they
be properly armed." --Alexander Hamilton

_______________________________________________
Imap-uw mailing list
[email-masked]
https://mailman1.u.washington.edu/mailman/listinfo/imap-uw

---

From: Mark Crispin <[email-masked]>
Date: Wed, 17 Aug 2005 15:38:40 -0700 (Pacific Daylight Time)

On Wed, 17 Aug 2005, Gregory Hicks wrote:
> works and keeps on working...

There are different definitions of "works".

The fact that imapd works as well as it does on SVR4 is largely due to 
extensive workarounds (developed over a period of *years*) to the 
deficiencies in that kernel.  The only purpose of those workarounds is to 
get SVR4 to run as close to "as well as Linux and BSD" as possible.

Nevertheless, imapd does not, and will never, work as well on SVR4 systems 
(such as Solaris) as on comparable hardware running Linux or BSD.  I wish 
that was not the case.  After years of beating my head against the SVR4 
brick wall, I conceed defeat.

The worst problem with SVR4 is that imapd is obliged to use POSIX locking 
instead of BSD-style flock().  This, in turn, requires it to spawn a child 
process to support the DELETE, RENAME, STATUS, SCAN, COPY, and APPEND 
commands, along with an elaborate communication protocol that has to take 
place between imapd and this child process.  This consumes greater systems 
resources and adds fragility, yet has not fully overcome the problems 
caused by POSIX locking.

The bottom line is that, for whatever definition of "works" that you 
observe on your Solaris (or other SVR4) system, imapd will always work 
*better* under Linux or BSD: fewer crashes, fewer corrupted mailboxes, and 
the ability to run more simultaneous sessions faster.

-- Mark --

http://staff.washington.edu/mrc
Science does not emerge from voting, party politics, or public debate.
Si vis pacem, para bellum.
_______________________________________________
Imap-uw mailing list
[email-masked]
https://mailman1.u.washington.edu/mailman/listinfo/imap-uw